<template>
    <div>
        <br>
        <div>
            <h5>Neuen Unterrichtstag erstellen</h5>
            <b-button id="show-btn" variant="success" @click="showModal">
                <b-icon icon="plus-square" aria-hidden="true"></b-icon>
            </b-button>

            <b-modal ref="my-modal" @hidden="resetModal" hide-footer>
                <div class="d-block text-center">
                    <form method="post">
                        <b-container fluid>

                            <b-row class="my-1">
                                <b-col sm="1">
                                </b-col>
                                <b-col sm="10">
                                    <label for="tags-basic">Tag wählen</label>
                                    <select class="form-select form-select-lg mb-3" aria-label=".form-select-lg example"
                                        v-model="unterrichtstag.tageEnums">
                                        <option value="MONTAG">Montag</option>
                                        <option value="DIENSTAG">Dienstag</option>
                                        <option value="MITTWOCH">Mittwoch</option>
                                        <option value="DONNERSTAG">Donnerstag</option>
                                        <option value="FREITAG">Freitag</option>
                                    </select>
                                </b-col>
                            </b-row>                        
                            
                            <b-row class="my-1">
                                <b-col sm="1">
                                </b-col>
                                <b-col sm="10">
                                    <label for="tags-basic">Unterrichtseinheit auswählen</label>
                                    <select class="form-select form-select-lg mb-3" aria-label=".form-select-lg example"
                                        v-model="unterrichtstag.fachId">
                                        <option v-for="fach in faecher" v-bind:key="fach.id"
                                            :value="fach.fach_id"> {{ fach.fachEnums }}, {{ fach.description }}
                                        </option>
                                    </select>
                                </b-col>
                            </b-row>

                            <b-row class="my-1">
                                <b-col sm="1">
                                </b-col>
                                <b-col sm="10">
                                    <label for="tags-basic">Gruppe auswählen</label>
                                    <select class="form-select form-select-lg mb-3" aria-label=".form-select-lg example"
                                        v-model="unterrichtstag.gruppeId">
                                        <option v-for="gruppe in gruppen" v-bind:key="gruppe.id"
                                            :value="gruppe.gruppen_ID"> {{ gruppe.gruppenEnums }}.{{ gruppe.nummer }}
                                        </option>
                                    </select>
                                </b-col>
                            </b-row>

                            <b-row class="my-1">
                                <b-col sm="1">
                                </b-col>
                                <b-col sm="10">
                                    <label for="tags-basic">TrainerIn auswählen</label>
                                    <select class="form-select form-select-lg mb-3" aria-label=".form-select-lg example"
                                        v-model="unterrichtstag.trainerId">
                                        <option v-for="trainer in trainerIn" v-bind:key="trainer.id"
                                            :value="trainer.id"> {{ trainer.name }}
                                        </option>
                                    </select>
                                </b-col>
                            </b-row>

                        </b-container>
                        <div>
                            <b-button block variant="outline-success" @click="postUnterrichtstag()">
                                Speichern</b-button>
                        </div>
                    </form>
                </div>
            </b-modal>

        </div>

        <div>
            <b-modal ref="my-modal1" @hidden="resetModal" hide-footer>
                <div class="d-block text-center">
                    <form method="post">
                        <b-container fluid>

                            <b-row class="my-1">
                                <b-col sm="1">
                                </b-col>
                                <b-col sm="10">
                                    <label for="tags-basic">Tag wählen</label>
                                    <select class="form-select form-select-lg mb-3" aria-label=".form-select-lg example"
                                        v-model="editUnterrichtstage.tageEnums">
                                        <option value="MONTAG">Montag</option>
                                        <option value="DIENSTAG">Dienstag</option>
                                        <option value="MITTWOCH">Mittwoch</option>
                                        <option value="DONNERSTAG">Donnerstag</option>
                                        <option value="FREITAG">Freitag</option>
                                    </select>
                                </b-col>
                            </b-row>

                            <b-row class="my-1">
                                <b-col sm="1">
                                </b-col>
                                <b-col sm="10">
                                    <label for="tags-basic">Unterrichtseinheit auswählen</label>
                                    <select class="form-select form-select-lg mb-3" aria-label=".form-select-lg example"
                                        v-model="editUnterrichtstage.fachId">
                                        <option v-for="fach in faecher" v-bind:key="fach.id"
                                            :value="fach.fach_id"> {{ fach.fachEnums }}, {{ fach.description }}
                                        </option>
                                    </select>
                                </b-col>
                            </b-row>

                            <b-row class="my-1">
                                <b-col sm="1">
                                </b-col>
                                <b-col sm="10">
                                    <label for="tags-basic">Gruppe auswählen</label>
                                    <select class="form-select form-select-lg mb-3" aria-label=".form-select-lg example"
                                        v-model="editUnterrichtstage.gruppeId">
                                        <option v-for="gruppe in gruppen" v-bind:key="gruppe.id"
                                            :value="gruppe.gruppen_ID"> {{ gruppe.gruppenEnums }}.{{ gruppe.nummer }}
                                        </option>
                                    </select>
                                </b-col>
                            </b-row>

                            <b-row class="my-1">
                                <b-col sm="1">
                                </b-col>
                                <b-col sm="10">
                                    <label for="tags-basic">TrainerIn auswählen</label>
                                    <select class="form-select form-select-lg mb-3" aria-label=".form-select-lg example"
                                        v-model="editUnterrichtstage.trainerId">
                                        <option v-for="trainer in trainerIn" v-bind:key="trainer.id"
                                            :value="trainer.id"> {{ trainer.name }}
                                        </option>
                                    </select>
                                </b-col>
                            </b-row>

                            <!-- <b-row class="my-1">
                                <b-col sm="1">
                                </b-col>
                                <b-col sm="10">
                                    <b-form-input id="input-large" size="lg" placeholder="Fach eingeben"
                                        v-model="editUnterrichtstage.fachId"></b-form-input>
                                </b-col>
                            </b-row> -->  

                        </b-container>
                        <div>
                            <b-button block variant="outline-success" @click="putUnterrichtstag()">
                                Speichern</b-button>
                        </div>
                    </form>
                </div>
            </b-modal>
        </div>

        <br>
        <h1>Alle Unterrichtstage</h1>

        <table class="table">
            <tbody>
                <tr>
                    <!-- <th>ID</th> -->
                    <th>Tag</th>
                    <th>Fach</th>
                    <th>Gruppe</th>
                    <th>TrainerIn</th>
                    <th></th>
                    <th></th>
                </tr>
                <tr v-for="unterrichtstag in unterrichtstage" v-bind:key="unterrichtstag.id">
                    <!-- <td>{{ unterrichtstag.unterrichtId }}</td> -->
                    <td>{{ unterrichtstag.tageEnums }}</td>
                    <td>{{ unterrichtstag.fach.fachEnums }}</td>
                    <td>{{ unterrichtstag.gruppe.gruppenEnums }}.{{ unterrichtstag.gruppe.nummer }}</td>
                    <td>{{ unterrichtstag.trainerInnen.name }}</td>
                    <td>
                        <b-button id="show-btn"
                            @click="showModal1(unterrichtstag.unterrichtId), editUnterrichtstag(unterrichtstag)"
                            variant="primary">
                            <b-icon icon="pencil" aria-hidden="true"></b-icon>
                        </b-button>
                    </td>
                    <td>
                        <b-button @click="deleteUnterrichtstag(unterrichtstag.unterrichtId)" variant="danger">
                            <b-icon icon="trash-fill" aria-hidden="true"></b-icon>
                        </b-button>
                    </td>
                </tr>
            </tbody>

        </table>
    </div>
</template>

<script>

export default {
    name: "UnterrichtsTagListe",
    data() {
        return {
            modalShow: false,
            unterrichtstag: {
                tageEnums: '',
                fachId: '',
                gruppeId: '',
                trainerId: ''
            },
            editUnterrichtstage: {
                tageEnums: '',
                fachId: '',
                gruppeId: '',
                trainerId: '',
                unterrichtId: ''
            }
        }
    },
    computed: {
        unterrichtstage() {
            return this.$store.state.unterrichtstage;
        },
        trainerIn() {
            return this.$store.state.trainerIn;
        },
        gruppen() {
            return this.$store.state.gruppen;
        },
        faecher() {
            return this.$store.state.faecher;
        }


    },
    methods:
    {
        deleteUnterrichtstag(unterrichtId) {
            this.$store.dispatch('deleteUnterrichtstag', unterrichtId)
        },

        postUnterrichtstag() {
            this.$store.dispatch('postUnterrichtstag', this.unterrichtstag)
            this.hideModal()
        },

        putUnterrichtstag() {
            this.$store.dispatch('putUnterrichtstag', this.editUnterrichtstage)
            this.hideModal1()
        },

        async editUnterrichtstag(unterrichtstag) {
            this.editUnterrichtstage.tageEnums = unterrichtstag.tageEnums;
            this.editUnterrichtstage.fachId = unterrichtstag.fachId;
            this.editUnterrichtstage.gruppeId = unterrichtstag.gruppeId;
            this.editUnterrichtstage.trainerId = unterrichtstag.trainerId;
            this.editUnterrichtstage.unterrichtId = unterrichtstag.unterrichtId;
        },

        resetModal() {
                this.unterrichtstag.tageEnums = '',
                this.unterrichtstag.fachId = '',
                this.unterrichtstag.gruppeId = '',
                this.unterrichtstag.trainerId = ''
        },
        showModal() {
            this.$refs['my-modal'].show()
        },
        showModal1() {
            this.$refs['my-modal1'].show()
        },
        hideModal() {
            this.$refs['my-modal'].hide()
        },
        hideModal1() {
            this.$refs['my-modal1'].hide()
        }
    },
    mounted() {
        this.$store.dispatch('getAlleUnterrichtstage');
        this.$store.dispatch('getAlleTrainnerInnen');
        this.$store.dispatch('getAlleGruppen');
        this.$store.dispatch('getAlleFaecher');
    }
}
</script>